/*
     RoadRunner - an automatic wrapper generation system for Web data sources
     Copyright (C) 2003  Valter Crescenzi - crescenz@dia.uniroma3.it

     This program is  free software;  you can  redistribute it and/or
     modify it  under the terms  of the GNU General Public License as
     published by  the Free Software Foundation;  either version 2 of
     the License, or (at your option) any later version.

     This program is distributed in the hope that it  will be useful,
     but  WITHOUT ANY WARRANTY;  without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
     General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the:

     Free Software Foundation, Inc.,
     59 Temple Place, Suite 330,
     Boston, MA 02111-1307 USA

     ----

     RoadRunner - un sistema per la generazione automatica di wrapper su sorgenti Web
     Copyright (C) 2003  Valter Crescenzi - crescenz@dia.uniroma3.it

     Questo  programma   software libero;   lecito redistribuirlo  o
     modificarlo secondo i termini della Licenza Pubblica Generica GNU
     come  pubblicata dalla Free Software Foundation; o la versione 2
     della licenza o (a propria scelta) una versione successiva.

     Questo programma   distribuito nella speranza che sia  utile, ma
     SENZA  ALCUNA GARANZIA;  senza neppure la  garanzia implicita  di
     NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO. Si
     veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

     Questo  programma deve  essere  distribuito assieme  ad una copia
     della Licenza Pubblica Generica GNU; in caso contrario, se ne pu
     ottenere  una scrivendo  alla:

     Free  Software Foundation, Inc.,
     59 Temple Place, Suite 330,
     Boston, MA 02111-1307 USA

*/
/*
 * IteratorsStack.java
 *
 * Created on 24 aprile 2003, 17.47
 * @author  Valter Crescenzi
 */

package roadrunner.ast;

import java.util.*;

public class IteratorsStack {
    
    private Stack stack;
    
    /** Creates a new instance of IteratorsStack */
    public IteratorsStack() {
        this.stack = new Stack();
    }
    
    public void register(ListIterator lit) {
        this.stack.push(lit);
    }
    
    public void unregister(ListIterator lit) {
        Object popped = this.stack.pop();
        if (popped!=lit)
            throw new RuntimeException("Popped element is not the expected one!");
    }
    
    public int[] makeIndices() {
        int indices[] = new int[this.stack.size()], i = 0;
        Iterator it = this.stack.iterator();
        while (it.hasNext()) {
            indices[i++] = ((ListIterator)it.next()).previousIndex();
        }
        return indices;
    }
    
}
